package dev.shadowsoffire.apotheosis.adventure.affix.salvaging;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.gson.JsonObject;
import com.mojang.datafixers.util.Pair;
import com.mojang.serialization.DynamicOps;
import com.mojang.serialization.JsonOps;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingRecipe;
import java.util.List;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.NbtOps;
import net.minecraft.nbt.Tag;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.util.GsonHelper;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeSerializer;

public class Serializer implements RecipeSerializer<SalvagingRecipe> {
  public static final Serializer INSTANCE = new Serializer();
  
  public SalvagingRecipe fromJson(ResourceLocation id, JsonObject obj) {
    List<SalvagingRecipe.OutputData> outputs = (List<SalvagingRecipe.OutputData>)((Pair)SalvagingRecipe.OutputData.LIST_CODEC.decode((DynamicOps)JsonOps.INSTANCE, GsonHelper.m_13933_(obj, "outputs")).result().get()).getFirst();
    Ingredient input = Ingredient.m_43917_(obj.get("input"));
    return new SalvagingRecipe(id, outputs, input);
  }
  
  public SalvagingRecipe fromNetwork(ResourceLocation id, FriendlyByteBuf buf) {
    List<SalvagingRecipe.OutputData> outputs = (List<SalvagingRecipe.OutputData>)((Pair)SalvagingRecipe.OutputData.LIST_CODEC.decode((DynamicOps)NbtOps.f_128958_, buf.m_130260_().m_128423_("outputs")).result().get()).getFirst();
    Ingredient input = Ingredient.m_43940_(buf);
    return new SalvagingRecipe(id, outputs, input);
  }
  
  public void toNetwork(FriendlyByteBuf buf, SalvagingRecipe recipe) {
    Tag outputs = SalvagingRecipe.OutputData.LIST_CODEC.encodeStart((DynamicOps)NbtOps.f_128958_, recipe.outputs).get().left().get();
    CompoundTag netWrapper = new CompoundTag();
    netWrapper.m_128365_("outputs", outputs);
    buf.m_130079_(netWrapper);
    recipe.input.m_43923_(buf);
  }
}
